
greenBalls=class()

function greenBalls:init()
    self.greenBallsTab={}
    self.xPos=0
    self.yPos=0
    self.zPos=0
    self.xVel=0
    self.yVel=0
    self.zVel=0
    self.size=.5
    self.ballCount=100
    self.color=color(0,255,0)
    self.number=0
    self.ballsLeft=self.ballCount
    self.greenGlowyMaterial = craft.material(asset.builtin.Materials.Basic) 
    self.greenGlowyMaterial.diffuse = vec3(55/255, 250/255, 90/255) * 3.75
end

function greenBalls:create()
    for z=1,self.ballCount do    -- green balls
        self.xVel=math.random(-10,10)/200
        self.yVel=math.random(-10,10)/200
        self.zVel=math.random(-10,10)/200
        if self.xVel==0 and self.yVel==0 and self.zVel==0 then
            self.xVel=.1
            self.yVel=.1
            self.zVel=.1
        end
        self.xPos=math.random(-200,200)
        self.yPos=1
        self.zPos=math.random(-200,200)
        self:createSphere(self.xPos,self.zPos,self.size,self.color,
                self.xVel,self.yVel,self.zVel)
        self.number=self.number+1
    end
end

function greenBalls:createSphere()
    sphere1=scene:entity()
    sphere1.model = craft.model.icosphere(self.size,1)
    if mn.flying=="On" then
        sphere1.position=vec3(self.xPos,math.random(1,30),self.zPos)
    else
        sphere1.position=vec3(self.xPos,1,self.zPos)
        yv=0
    end
    sphere1.material = self.greenGlowyMaterial
    table.insert(self.greenBallsTab,
    {ent=sphere1,xv=self.xVel,yv=self.yVel,zv=self.zVel,size=self.size})
end

function greenBalls:draw()
end

function greenBalls:collision()
    for a,b in pairs(self.greenBallsTab) do    -- green balls
        if sh.cameraX>b.ent.position.x-b.size and
        sh.cameraX<b.ent.position.x+b.size and
        sh.cameraY>b.ent.position.y-b.size and
        sh.cameraY<b.ent.position.y+b.size and
        sh.cameraZ>b.ent.position.z-b.size and
        sh.cameraZ<b.ent.position.z+b.size then
            b.ent:destroy()
            table.remove(self.greenBallsTab,a)
            self.number=self.number-1
            sound(SOUND_HIT, 19423)
            self.ballsLeft=self.ballsLeft-1
            if self.ballsLeft==0 then
                sc.youWon=true
            end
            if mn.flying=="On" then
                for z=1,10 do
                    wa:createWall()
                end
            else
                wa:createWall()
            end
            if sc.pct<1 then
                sc.pct=sc.pct+.02
            end
            if self.ballsLeft<sc.lowScore then
                sc.lowScore=self.ballsLeft
                saveProjectData("Low_Score",sc.lowScore)
            end
        end
    end
end

function greenBalls:move()
    if self.ballsLeft<50 then    -- start moving green balls
        for a,b in pairs(self.greenBallsTab) do
            self.xPos=b.ent.position.x
            self.yPos=b.ent.position.y
            self.zPos=b.ent.position.z
            self.xPos=self.xPos+b.xv
            self.yPos=self.yPos+b.yv
            self.zPos=self.zPos+b.zv
            if self.xPos<-200 or self.xPos>200 then
                b.xv=-b.xv
            end
            if self.yPos<0 or self.yPos>30 then
                b.yv=-b.yv
            end
            if self.zPos<-200 or self.zPos>200 then
                b.zv=-b.zv
            end
            b.ent.position=vec3(self.xPos,self.yPos,self.zPos)
        end
    end
end
