
menu=class()

function menu:init()
    self.showFuel="Off"
    self.showMap="Off"
    self.flying="Off"
    self.speedTab={"Slow","S / M","Medium","M / F","Fast"}
end

function menu:draw()
    pushStyle()
    rectMode(CENTER)
    background(182, 220, 224)
    fill(0)
    text("Tap a button to make a selection.",WIDTH/2,HEIGHT-100)
    self:fuel()
    self:map()
    self:speed()
    self:flyOn()
    self:resetScore()
    self:play()
    popStyle()
end

function menu:fuel()
    fill(255)
    if self.showFuel=="On" then
        fill(0,255,0)
    end
    rect(WIDTH/2,HEIGHT*.8,200,50)
    fill(0)
    text("Show Fuel Level....  "..self.showFuel,WIDTH/2,HEIGHT*.8)
end

function menu:map()
    fill(255)
    if self.showMap=="On" then
        fill(0,255,0)
    end
    rect(WIDTH/2,HEIGHT*.7,200,50)
    fill(0)
    text("Show Map....  "..self.showMap,WIDTH/2,HEIGHT*.7)
end

function menu:speed()
    fill(255)
    for z=1,5 do
        fill(255)
        if z/10==sc.maxSpeed then
            fill(67, 171, 236)
        end
        local xx=(z-3)*100
        rect(WIDTH/2+xx,HEIGHT*.45,80,50)
    end
    fill(0)
    text("<=====  Speed  =====>",WIDTH/2,HEIGHT*.5)
    for z=1,5 do
        local xx=(z-3)*100
        text(self.speedTab[z],WIDTH/2+xx,HEIGHT*.45)
    end
end

function menu:flyOn()
    fill(255)
    if self.flying=="On" then
        fill(0,255,0)
    end
    rect(WIDTH/2,HEIGHT*.6,200,50)
    fill(0)
    text("Allow Flying....  "..self.flying,WIDTH/2,HEIGHT*.6)
end

function menu:resetScore()
    fill(255)
    if sc.lowScore==sc.count then
        fill(0,255,0)
    end
    rect(WIDTH/2,HEIGHT*.3,200,50)
    fill(0)
    text("Reset Low Score... "..string.format("%d",sc.lowScore),WIDTH/2,HEIGHT*.3)
end

function menu:play()
    fill(255)
    rect(WIDTH/2,100,100,50)
    fill(0)
    text("Play",WIDTH/2,100)
end

function menu:touched(t)
    if t.state==BEGAN then
        -- fuel
        if t.x>WIDTH/2-100 and t.x<WIDTH/2+100 and
        t.y>HEIGHT*.8-25 and t.y<HEIGHT*.8+25 then
            sound(SOUND_BLIT, 41111)
            if self.showFuel=="On" then
                self.showFuel="Off"
            else
                self.showFuel="On"
            end
        end
        -- map
        if t.x>WIDTH/2-100 and t.x<WIDTH/2+100 and
        t.y>HEIGHT*.7-25 and t.y<HEIGHT*.7+25 then
            sound(SOUND_BLIT, 41111)
            if self.showMap=="On" then
                self.showMap="Off"
            else
                self.showMap="On"
            end
        end
        -- flying
        if t.x>WIDTH/2-100 and t.x<WIDTH/2+100 and
        t.y>HEIGHT*.6-25 and t.y<HEIGHT*.6+25 then
            sound(SOUND_BLIT, 41111)
            if self.flying=="On" then
                self.flying="Off"
            else
                self.flying="On"
            end
        end
        -- play
        if t.x>WIDTH/2-100 and t.x<WIDTH/2+100 and
        t.y>50 and t.y<150 then
            sound(SOUND_BLIT, 41111)
            sc.showMenu=false
            sh.gyOrig=Gravity.y
            sc:setup1()
            sc.playGame=true
        end
        -- speed
        for z=1,5 do
            xx=(z-3)*100
            if t.x>WIDTH/2+xx-50 and t.x<WIDTH/2+xx+50 and
            t.y>HEIGHT*.45-25 and t.y<HEIGHT*.45+25 then
                sound(SOUND_BLIT, 41111)
                sc.maxSpeed=z/10
            end
            
        end
        -- reset score
        if t.x>WIDTH/2-100 and t.x<WIDTH/2+100 and
        t.y>HEIGHT*.3-25 and t.y<HEIGHT*.3+25 then
            sound(SOUND_BLIT, 41111)
            saveProjectData("Low_Score",sc.count)
            sc.lowScore=sc.count
        end
        return
    end
end