
wall=class()

function wall:init()
    self.wallTab={}
    self.xPos=0
    self.yPos=0
    self.zPos=0
    self.xSize=0
    self.ySize=0
    self.zSize=0
    self.img=readImage(asset.builtin.Surfaces.Basic_Bricks_Roughness)
end

function wall:createWall(xp,yp,zp,xs,ys,zs)
    local c1=scene:entity()
    if xp~=nil then -- outside walls
        self.xPos=xp
        self.zPos=zp
        self.xSize=xs
        self.zSize=zs
        --self.yPos = 2
        self.yPos = -4
        --self.ySize=4
        self.ySize=34
        if mn.flying=="On" then            
            --self.ySize=120
            self.ySize=140
        end
    else
        self.xPos=math.random(-195,195)
        self.zPos=math.random(-195,195)
        --self.yPos = 2 of
        self.yPos = -4
        --self.ySize=4
        self.ySize=34
        self.xSize=50
        self.zSize=2
        if math.random(100)<51 then
            self.xSize=2
            self.zSize=80
        end
        if mn.flying=="On" then
            self.xSize=math.random(10)
            self.zSize=math.random(10)
        end
    end
    if mn.flying=="On" and xp==nil then
        --self.ySize=math.random(10,40)
        --self.yPos=self.ySize/2   
        self.ySize=math.random(10,40) + 40
        self.yPos=self.ySize/2  - 20      
    end
    
    -- Assuming the wall faces along the x-axis or z-axis:
    local textureBaseSize = 46
    local textureRepeatX = self.xSize / textureBaseSize
    local textureRepeatY = self.ySize / textureBaseSize
    local textureRepeatZ = self.zSize / textureBaseSize
    
    -- Determine the wall orientation and apply the correct repeats
    local horizontalRepeat = 1, 1
    if self.xSize > self.zSize then
        -- Wall is along the x-axis
        horizontalRepeat = textureRepeatX
    else
        -- Wall is along the z-axis
        horizontalRepeat = textureRepeatZ
    end
    
    c1.material = craft.material(asset.builtin.Materials.Standard)
    c1.material.map = self.img
    c1.material.roughness = 100
    c1.material.roughnessMap = readImage(asset.builtin.Surfaces.Basic_Bricks_Roughness)
    c1.material.normalMap = readImage(asset.builtin.Surfaces.Basic_Bricks_Normal)
    -- Applying calculated texture repeats
    c1.material.offsetRepeat = vec4(1, 1, horizontalRepeat, textureRepeatY)
    
    c1.model=craft.model.cube(vec3(self.xSize,self.ySize,self.zSize))
    c1.position=vec3(self.xPos,self.yPos,self.zPos)
    table.insert(self.wallTab,{xp=self.xPos,yp=self.yPos,zp=self.zPos,
    xs=self.xSize,ys=self.ySize,zs=self.zSize})
end

function wall:draw()
end

function wall:collision()
    for a,b in pairs(self.wallTab) do    -- check collision with wall
        if sh.cameraX>b.xp-b.xs/2 and
        sh.cameraX<b.xp+b.xs/2 and
        sh.cameraY>b.yp-b.ys/2 and
        sh.cameraY<b.yp+b.ys/2 and
        sh.cameraZ>b.zp-b.zs/2 and
        sh.cameraZ<b.zp+b.zs/2 then
            if sh.ships==0 then
                sound(SOUND_POWERUP, 20465)
                sc.youLost=true
            else
                sound(SOUND_EXPLODE, 20445)
                sc.hitWall=true
            end
        end
    end
end
